package com.ynet.life.sujrb.action;

import com.sun.image.codec.jpeg.JPEGCodec;
import com.sun.imageio.plugins.bmp.BMPImageReader;
import com.sun.imageio.plugins.gif.GIFImageReader;
import com.sun.imageio.plugins.jpeg.JPEGImageReader;
import com.sun.imageio.plugins.png.PNGImageReader;
import com.ynet.gene.core.Context;
import com.ynet.gene.core.GENEException;
import com.ynet.gene.web.multipart.implement.GENEMultipartFile;
import com.ynet.life.base.LifeAction;
import com.ynet.life.base.LifeDBAccess;
import com.ynet.life.base.Trace;
import com.ynet.life.sujrb.img.AnimatedGifEncoder;
import com.ynet.life.sujrb.img.GifDecoder;
import java.awt.BasicStroke;
import java.awt.Color;
import java.awt.Graphics2D;
import java.awt.RenderingHints;
import java.awt.geom.AffineTransform;
import java.awt.image.BufferedImage;
import java.awt.image.ColorModel;
import java.awt.image.ImageObserver;
import java.awt.image.WritableRaster;
import java.io.BufferedInputStream;
import java.io.BufferedOutputStream;
import java.io.ByteArrayInputStream;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.sql.Connection;
import java.util.Hashtable;
import java.util.Iterator;
import javax.imageio.ImageIO;
import javax.imageio.ImageReader;
import javax.imageio.stream.MemoryCacheImageInputStream;

/* loaded from: com_ynet_life_sujrb_action.jar:com/ynet/life/sujrb/action/ChangImgAction.class */
public class ChangImgAction extends LifeAction {
    private static final char DIR_SEPERATOR = '/';
    private String fileUploadField;
    private String ftpFileField;

    public String execute(Context context) throws GENEException {
        try {
            try {
                String filePathName = ((GENEMultipartFile) context.getDataValue(this.fileUploadField)).getTempFileName();
                System.out.println("23413242342342424242434343".concat(String.valueOf(filePathName)));
                InputStream inputStream1 = new FileInputStream(filePathName);
                String fileType = getImageType(filePathName);
                OutputStream outputStream1 = new BufferedOutputStream(new FileOutputStream(filePathName));
                if ("gif".equals(fileType)) {
                    GifDecoder decoder = new GifDecoder();
                    decoder.read(inputStream1);
                    AnimatedGifEncoder e = new AnimatedGifEncoder();
                    e.start(outputStream1);
                    e.setRepeat(decoder.getLoopCount());
                    e.setTransparent(Color.BLACK);
                    int n = decoder.getFrameCount();
                    for (int i = 0; i < n; i++) {
                        BufferedImage targetFrame = resize(decoder.getFrame(i), 65, 69);
                        e.setDelay(decoder.getDelay(i));
                        e.addFrame(targetFrame);
                    }
                    e.finish();
                } else if ("png".equals(fileType)) {
                    ImageIO.write(resize(ImageIO.read(inputStream1), 65, 69), "png", outputStream1);
                } else {
                    BufferedImage image = ImageIO.read(inputStream1);
                    BufferedImage tag = new BufferedImage(65, 69, 1);
                    tag.getGraphics().drawImage(image.getScaledInstance(65, 69, 4), 0, 0, (ImageObserver) null);
                    JPEGCodec.createJPEGEncoder(outputStream1).encode(tag);
                }
                outputStream1.flush();
                outputStream1.close();
                inputStream1.close();
                try {
                    LifeDBAccess.releaseConnection((Connection) null);
                    return "0";
                } catch (GENEException e2) {
                    Trace.logError("LifeAction", "数据库上传文件异常GENE", e2);
                    return "0";
                }
            } catch (Throwable th) {
                try {
                    LifeDBAccess.releaseConnection((Connection) null);
                } catch (GENEException e3) {
                    Trace.logError("LifeAction", "数据库上传文件异常GENE", e3);
                }
                throw th;
            }
        } catch (FileNotFoundException e4) {
            Trace.logError("LifeAction", "数据库上传文件异常FILE", e4);
            try {
                LifeDBAccess.releaseConnection((Connection) null);
                return "0";
            } catch (GENEException e5) {
                Trace.logError("LifeAction", "数据库上传文件异常GENE", e5);
                return "0";
            }
        } catch (IOException e6) {
            Trace.logError("LifeAction", "数据库上传文件异常FILE", e6);
            try {
                LifeDBAccess.releaseConnection((Connection) null);
                return "0";
            } catch (GENEException e7) {
                Trace.logError("LifeAction", "数据库上传文件异常GENE", e7);
                return "0";
            }
        }
    }

    private static BufferedImage resize1(BufferedImage source, int new_w, int new_h) {
        Graphics2D g2d = new BufferedImage(new_w, new_h, 1).createGraphics();
        BufferedImage image_bg = g2d.getDeviceConfiguration().createCompatibleImage(new_w, new_h, 3);
        g2d.dispose();
        Graphics2D g2d2 = image_bg.createGraphics();
        g2d2.setColor(new Color(0, 0, 0));
        g2d2.setStroke(new BasicStroke(0.0f));
        g2d2.drawImage(source.getScaledInstance(new_w, new_h, 4), 0, 0, (ImageObserver) null);
        g2d2.dispose();
        return image_bg;
    }

    private static BufferedImage resize(BufferedImage source, int targetW, int targetH) {
        BufferedImage target;
        int type = source.getType();
        double sx = targetW / source.getWidth();
        double sy = targetH / source.getHeight();
        if (sx < sy) {
            targetW = (int) (sx * source.getWidth());
        } else {
            targetH = (int) (sy * source.getHeight());
        }
        if (type == 0) {
            ColorModel cm = source.getColorModel();
            WritableRaster raster = cm.createCompatibleWritableRaster(targetW, targetH);
            boolean alphaPremultiplied = cm.isAlphaPremultiplied();
            target = new BufferedImage(cm, raster, alphaPremultiplied, (Hashtable) null);
        } else {
            target = new BufferedImage(targetW, targetH, type);
        }
        Graphics2D g = target.createGraphics();
        g.setRenderingHint(RenderingHints.KEY_INTERPOLATION, RenderingHints.VALUE_INTERPOLATION_NEAREST_NEIGHBOR);
        g.drawRenderedImage(source, AffineTransform.getScaleInstance(sx, sy));
        g.dispose();
        return target;
    }

    public static String getImageType(String path) throws IOException {
        FileInputStream fis = new FileInputStream(path);
        int leng = fis.available();
        BufferedInputStream buff = new BufferedInputStream(fis);
        byte[] mapObj = new byte[leng];
        buff.read(mapObj, 0, leng);
        String type = "";
        ByteArrayInputStream bais = null;
        MemoryCacheImageInputStream mcis = null;
        try {
            bais = new ByteArrayInputStream(mapObj);
            MemoryCacheImageInputStream memoryCacheImageInputStream = new MemoryCacheImageInputStream(bais);
            mcis = memoryCacheImageInputStream;
            Iterator itr = ImageIO.getImageReaders(memoryCacheImageInputStream);
            while (itr.hasNext()) {
                ImageReader reader = (ImageReader) itr.next();
                if (reader instanceof GIFImageReader) {
                    type = "gif";
                } else if (reader instanceof JPEGImageReader) {
                    type = "jpg";
                } else if (reader instanceof PNGImageReader) {
                    type = "png";
                } else if (reader instanceof BMPImageReader) {
                    type = "bmp";
                }
            }
            try {
                bais.close();
            } catch (IOException unused) {
            }
            try {
                mcis.close();
            } catch (IOException unused2) {
            }
            return type;
        } catch (Throwable th) {
            if (bais != null) {
                try {
                    bais.close();
                } catch (IOException unused3) {
                }
            }
            if (mcis != null) {
                try {
                    mcis.close();
                } catch (IOException unused4) {
                }
            }
            throw th;
        }
    }

    public void setFileUploadField(String fileUploadField) {
        this.fileUploadField = fileUploadField;
    }

    public void setFtpFileField(String ftpFileField) {
        this.ftpFileField = ftpFileField;
    }
}
